#include<stdio.h>
#include<stdlib.h>
#include<math.h>
#include "cquad.h"

double fun(double x);

int main()
{
    double a, b, epsabs, epsrel, result, abserr, omega, *alist, *blist, *rlist, *elist, **chebmo;
    int i, neval, ier, integr, last, *iord, *nnlog;

 // a and b are the integration limits
    a = 0.0;
    b = 1.0;

 // omega and integr determine the weight function
    omega = M_PI * 10.0;
    integr = 2;

 // epsabs and epsrel determine the accuracy requirement    
    epsabs = 0.0;
    epsrel = 0.001;

 // allocate memory
    iord = (int *) calloc(LIMIT, sizeof(int));
    nnlog = (int *) calloc(LIMIT, sizeof(int)); 
    alist = (double *) calloc(LIMIT, sizeof(double));
    blist = (double *) calloc(LIMIT, sizeof(double));
    rlist = (double *) calloc(LIMIT, sizeof(double));
    elist = (double *) calloc(LIMIT, sizeof(double));
    chebmo = (double **)calloc(MAXP1,sizeof(double *));
    for (i = 0; i < MAXP1; i++) 
       chebmo[i] = (double *)calloc(25,sizeof(double));

    result = cquad_dqawoe(fun, a, b, omega, integr, epsabs, epsrel, &abserr, &neval, &ier, alist, blist, rlist, elist, iord, &last, nnlog, chebmo);

 // print the result
    printf("\nFunction:  log(x) * sin(10x)  over [0, 1]\n");
    printf("\nIntegral approximation:           %lg\n", result);
    printf("Estimate of absolute error:        %lg\n", abserr);
    printf("Number of function evaluations:    %d\n", neval);
    printf("Error code:  %d\n\n", ier);

 // free allocated memory 
    free(iord);
    free(nnlog);
    free(alist);
    free(blist);
    free(rlist);
    free(elist);
    free(chebmo);
}
